import optparse
import pylab
import numpy
import linecache, copy
import matplotlib.pyplot as plt
import os, sys
from popen2 import Popen3



from palette import *



def Plot_Profile(Name, ncelltot, size, nline,ngen,MillGen):
    """ Plot profile of all proteins at time nline, size is the number of variables (proteins) in the cell, ncelltot the total number of cells in the embryo"""
    
    fig = pylab.figure()
    result = numpy.zeros((size, ncelltot),
                         dtype=float)  # creates a table result to store data, results[i,j] will contain the concentration of protein i in cell j at time defined by nline
    colors = color_generate(25)
    pylab.clf()
    legendkey = []
    linestyle = ['-', '--', ':', '-.']
    cursor = 0  # cursor will be the index of the column
    linecache.clearcache()
    line = linecache.getline(Name, nline - 1)  # get the line we want to plot
    pylab.rc('axes', linewidth=2)
    ax = pylab.gca()
    s = line.split()
    for index in s:  # takes each variable in the line
        if (cursor > 0):
            ncell = int((cursor - 1) / size)  #computes the corresponding cell : column 1 to size corresponds to cell 0, size+1 to 2*size corresponds to cell 1, ...
            ngene = cursor - 1 - size * ncell  #computes the corresponding gene
            try:
                result[ngene, ncell] = eval(index)  #assigns it to the table result
                #if (result[ngene,ncell]<0.1):
                #result[ngene,ncell]=10*eval(index)#Be careful of this when plotting a profile (discontinuity from 1->0.1

                #if (ngene==1) or (ngene==3):
                #result[ngene,ncell]=0.4*eval(index)

            except:
                print ngene, ncell, index
                print "Error in Plot_Profile"
        cursor += 1
    n_position = numpy.zeros((ncelltot), dtype=float)
    # print "Tab filled"
    style='-'
    style2='--'
     
   
    legendkey=[]
    pylab.plot(result[2], style2, color=colors[7], lw=3.0)
    pylab.plot(result[3], style2, color=colors[3], lw=3.0)
    pylab.plot(result[4], style2, color=colors[4], lw=3.0)
    pylab.plot(result[5], style2, color=colors[14], lw=3.0)
    pylab.plot(result[6], style2, color=colors[10], lw=3.0)
    #pylab.plot(Eve[2], style, color=colors[8], lw=3.0)
    pylab.plot(result[15], style, color=colors[8], lw=3.0)
    pylab.plot(result[17], style, color=colors[12], lw=3.0)  
    
    pylab.subplots_adjust(left=None, bottom=None, right=None, top=None, wspace=0.07, hspace=0.1)
    
    fontsize = 10
    for tick in ax.xaxis.get_major_ticks():
        tick.label1.set_fontsize(fontsize)
        tick.label1.set_fontweight('bold')
    for tick in ax.yaxis.get_major_ticks():
        tick.label1.set_fontsize(fontsize)
        tick.label1.set_fontweight('bold')
        
    fig.text(0.5, 0.04, 'Position',fontsize=20, ha='center', va='center',fontweight='bold')
    fig.text(0.06, 0.5, 'Concentration',fontsize=20, ha='center', va='center', rotation='vertical',fontweight='bold')
    



Plot_Profile("Buffer0",200,18,3000,0,[])
plt.show()
